assets = {}

function assets.animation(name,data) 
  
  local animObj = {}
  local animObj_
  animObj_ = lf.load(string.format("%s.anim",name))()
  
  animObj.framerate = tonumber(animObj_.framerate)
  animObj.__framerate = animObj_.framerate
  animObj.stage = 1
  --
  local states = {}
  local x,y,w,h
  for i,v in pairs(animObj_.states) do
    states[i] = {}
    for i1,v1 in ipairs(v) do
      x,y,w,h = unpack(v1)
      table.insert(states[i],lg.newQuad(x,y,w,h,0,0))
    end
  end
  
  animObj.states = states
  animObj.stateChanged = false
  animObj.lastState = "normal"
  animObj.state = "normal"
  animObj.stage = 1
  animObj.sprites = 1
  animObj.img = lg.newImage(string.format("%s.png",name))
  
  function animObj:update(dt)
    
    self.framerate = self.framerate - dt
    if self.framerate <= 0 then
      self.stage = self.stage + 1
      self.framerate = self.__framerate
    end
    
    if self.stage > self.sprites then
      self.stage = 1
    end
    
    if self.state ~= self.lastState then
      self.stage = 1
      self.framerate = self.__framerate
    end
    self.lastState = self.state
    
  end
  
  function animObj:draw(x,y,sx,sy,ox,oy,kx,ky)
	
	local xy = ("x: %d; y: %d"):format(x,y)
	local quad = tostring(self.states[self.state][self.stage])
	local stats = ("states: %s, state (current): %s, stage: %d, sprites: %d"):format(self.states,self.state,self.stage,self.sprites)
	local viewport = ("x:%d y:%d w:%d h:%d"):format(self.states[self.state][self.stage]:getViewport())
	lg.print(xy,5,165)
	lg.print(quad,5,205)
	lg.print(stats,5,245)
	lg.print(viewport,5,285)
    
    lg.draw(self.img, self.states[self.state][self.stage],x,y,sx,sy,ox,oy,kx,ky)
  end
  
  function animObj:getImage()
    return self.img
  end
  
  function animObj:getDimensions()
    local x,y,w,h = self.states[self.state][self.stage]:getViewport()
    return w,h
  end
  
  function animObj:setState(state)
    self.state = state
    self.sprites = #animObj.states[state]
  end
  
  animObj:setState("idle_down")
  
  return animObj
  
end