function love.load()
  io.stdout:setvbuf("no") --Disables console output buffering (Makes the output from "print" appear immediately on console)
  
  lf    = love.filesystem
  lg    = love.graphics
  lk    = love.keyboard
  lm    = love.mouse
  lmath = love.math
  windfield = require 'windfield'
  _input    = require 'input'
  require 'assets' 
  lg = love.graphics
  input = _input()
  world = windfield.newWorld(0,0,true)
  obstacle = world:newRectangleCollider(400,300,80,80)
  obstacle:setMass(1000)
  obstacle:setAngularDamping(obstacle:getMass())
  obstacle:setType("dynamic")
  
  player = world:newRectangleCollider(10,10,40,40)
  player:setType("dynamic")
  plspd = {200,10}
  player:setLinearDamping(plspd[2])
  player:setFixedRotation(true)
  
  input:bind("up","moveUp")
  input:bind("down","moveDown")
  input:bind("left","moveLeft")
  input:bind("right","moveRight")
  
  ground = world:newRectangleCollider(0, 550, 800, 50)
  ceiling = world:newRectangleCollider(0, 0, 800, 50)
  wall_left = world:newRectangleCollider(0, 0, 50, 600)
  wall_right = world:newRectangleCollider(750, 0, 50, 600)
  ground:setType('static')
  ceiling:setType('static')
  wall_left:setType('static')
  wall_right:setType('static')
  
  robin = assets.animation("robin")
  
end

function love.update(dt)
  
  world:update(dt)
  
  if input:down("moveUp") then
    player:applyLinearImpulse(0,-100)
  end
  if input:down("moveDown") then
    player:applyLinearImpulse(0,100)
  end
  if input:down("moveLeft") then
    player:applyLinearImpulse(-100,0)
  end
  if input:down("moveRight") then
    player:applyLinearImpulse(100,0)
  end
  
  local ix,iy = player:getLinearVelocity()
  if ix > plspd[1] then ix = plspd[1] end
  if iy > plspd[1] then iy = plspd[1] end
  if ix < -plspd[1] then ix = -plspd[1] end
  if iy < -plspd[1] then iy = -plspd[1] end
  player:setLinearVelocity(ix,iy)
  
  robin:update(dt)
  
end

function love.draw()
  
  local ww,hw = love.window.getMode()
  
  world:draw()
  local ix,iy = player:getLinearVelocity()
  lg.print("ix = "..ix,5,5)
  lg.print("iy = "..iy,5,45)
  
  local px,py = player:getPosition()
  lg.print("px = "..px,5,85)
  lg.print("py = "..py,5,125)
  
  local x,y = player:getPosition()
  local w,h = robin:getDimensions()
  local r   = player:getAngle()
  robin:draw(x,y,r,1,1,w/2,h/2)
  
end